\subsection{\pim}

\begin{frame}{\pim{} examples}
Multiple ways to add processing units in memory
\begin{example}
\begin{itemize}
  \item 3D die stacking
  \item Logic implemented with RAM (e.g. \upmem{})
\end{itemize}
\end{example}
\end{frame}


\subsection{\upmem{}}

\begin{frame}{\upmem{} architecture overview}
  \begin{figure}
  \centering
  \includegraphics[scale=0.45]{upmemarch}
  \end{figure}
  %Legend
  \begin{description}
    \item[DPU] \textsc{dram} processing-unit
    \item[WRAM] execution memory for programs
    \item[MRAM] main memory
  \end{description}

\end{frame}


\begin{frame}{A massively parallel architecture}
% \begin{tikzpicture}[remember picture,overlay]
%     \node[xshift=-2cm,yshift=-2cm] at (current page.north east) {\includegraphics[width=4cm]{upmemarch}};
% \end{tikzpicture}
\begin{block}{Characteristics}
  \begin{itemize}
    \item Several DIMMs can be added to a CPU
    \item A 16 GBytes DIMM embeds 256 DPUs
    \item Each DPU can support up to 24 threads
  \end{itemize}
    
\end{block}

\vfill

  The context is switched between DPU threads every clock cycle.
  
  %Transition
  \pause
  \vfill
  \textit{The programming approach has to consider this fine-grained parallelism.}
\end{frame}


\begin{frame}{Programming approach on \upmem}
On a programming level: two programs must be specified.
  \begin{figure}
    \hspace{-21cm}
    \begin{overlayarea}{0cm}{2cm}
    \includegraphics<1>[scale=0.7]{tasklet1}
    \includegraphics<2>[scale=0.7]{tasklet2}
    \end{overlayarea}
  \end{figure}
\end{frame}


\begin{frame}{Communication}

\begin{columns}
\begin{column}{0.5\textwidth}
\textbf{MRAM}
\end{column}

\begin{column}{0.5\textwidth}
\textbf{Mailboxes}
\end{column}
\end{columns}

\vfill

\begin{columns}
\begin{column}{0.5\textwidth}
  \begin{figure}
  	\centering
  	\includegraphics[width=0.8\textwidth]{mram_com}
  \end{figure}
\end{column}

\begin{column}{0.5\textwidth}
    \begin{figure}
    	\centering
    	\includegraphics[width=0.8\textwidth]{wram_com}
    \end{figure}
\end{column}
\end{columns}

\vfill

\begin{columns}
\begin{column}{0.5\textwidth}
     \begin{itemize}
      \item Slow
      \item Large amount of data
     \end{itemize}
\end{column}

\begin{column}{0.5\textwidth}
     \begin{itemize}
      \item Fast
      \item Synchronization
     \end{itemize}
\end{column}
\end{columns}

\end{frame}


\begin{frame}{Drawbacks and advantages}
\begin{block}{Drawbacks: computation power}
 \begin{itemize}
   \item Frequency around 750 MHz
   \item No floating point operations
   \item Significant multiplication overhead
   \item Explicit memory management
  \end{itemize}
\end{block}

\vfill

\begin{block}{Advantages: data access}
 \begin{itemize}
  \item Parallelization power
  \item Minimum latency
  \item Increased bandwidth
  \item Reduced power consumption
 \end{itemize}
\end{block}

\vfill

%Transition
  \pause
  \textit{Ideal for data-intensive operations such as the \kmeans{} algorithm.}
  
\end{frame}
